import { Injectable, Component, Input, NgModule, defineInjectable } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularDataTableService = /** @class */ (function () {
    function AngularDataTableService() {
    }
    /**
     * @param {?} totalItems
     * @param {?=} currentPage
     * @param {?=} pageSize
     * @return {?}
     */
    AngularDataTableService.prototype.getPager = /**
     * @param {?} totalItems
     * @param {?=} currentPage
     * @param {?=} pageSize
     * @return {?}
     */
    function (totalItems, currentPage, pageSize) {
        if (currentPage === void 0) { currentPage = 1; }
        if (pageSize === void 0) { pageSize = 12; }
        // calculate total pages
        /** @type {?} */
        var totalPages = Math.ceil(totalItems / pageSize);
        // ensure current page isn't out of range
        if (currentPage < 1) {
            currentPage = 1;
        }
        else if (currentPage > totalPages) {
            currentPage = totalPages;
        }
        /** @type {?} */
        var startPage;
        /** @type {?} */
        var endPage;
        if (totalPages <= 12) {
            // less than 10 total pages so show all
            startPage = 1;
            endPage = totalPages;
        }
        else {
            // more than 10 total pages so calculate start and end pages
            if (currentPage <= 6) {
                startPage = 1;
                endPage = 12;
            }
            else if (currentPage + 4 >= totalPages) {
                startPage = totalPages - 9;
                endPage = totalPages;
            }
            else {
                startPage = currentPage - 5;
                endPage = currentPage + 4;
            }
        }
        // calculate start and end item indexes
        /** @type {?} */
        var startIndex = (currentPage - 1) * pageSize;
        /** @type {?} */
        var endIndex = Math.min(startIndex + pageSize - 1, totalItems - 1);
        // create an array of pages to ng-repeat in the pager control
        /** @type {?} */
        var pages = Array.from(Array((endPage + 1) - startPage).keys()).map((/**
         * @param {?} i
         * @return {?}
         */
        function (i) { return startPage + i; }));
        // return object with all pager properties required by the view
        return {
            totalItems: totalItems,
            currentPage: currentPage,
            pageSize: pageSize,
            totalPages: totalPages,
            startPage: startPage,
            endPage: endPage,
            startIndex: startIndex,
            endIndex: endIndex,
            pages: pages
        };
    };
    AngularDataTableService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AngularDataTableService.ctorParameters = function () { return []; };
    /** @nocollapse */ AngularDataTableService.ngInjectableDef = defineInjectable({ factory: function AngularDataTableService_Factory() { return new AngularDataTableService(); }, token: AngularDataTableService, providedIn: "root" });
    return AngularDataTableService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularDataTableComponent$$1 = /** @class */ (function () {
    function AngularDataTableComponent$$1(angularDataTableService) {
        this.angularDataTableService = angularDataTableService;
        // pager object
        this.pager = {};
        this.index = 1;
        this.bgColor = 'Black';
        this.currentPage = 1;
    }
    /**
     * @return {?}
     */
    AngularDataTableComponent$$1.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout((/**
         * @return {?}
         */
        function () {
            if (_this.data && _this.data.length > 0) {
                _this.totalItems = _this.data.length;
                _this.setPage(1);
            }
        }));
    };
    /**
     * @param {?} fieldName
     * @param {?} sortOrder
     * @return {?}
     */
    AngularDataTableComponent$$1.prototype.Sorting = /**
     * @param {?} fieldName
     * @param {?} sortOrder
     * @return {?}
     */
    function (fieldName, sortOrder) {
        if (sortOrder) {
            this.data.sort((/**
             * @param {?} objectOne
             * @param {?} objectTwo
             * @return {?}
             */
            function (objectOne, objectTwo) {
                if (objectOne[fieldName] < objectTwo[fieldName]) {
                    return -1;
                }
                if (objectOne[fieldName] > objectTwo[fieldName]) {
                    return 1;
                }
                return 0;
            }));
        }
        else {
            this.data.sort((/**
             * @param {?} objectOne
             * @param {?} objectTwo
             * @return {?}
             */
            function (objectOne, objectTwo) {
                if (objectOne[fieldName] > objectTwo[fieldName]) {
                    return -1;
                }
                if (objectOne[fieldName] < objectTwo[fieldName]) {
                    return 1;
                }
                return 0;
            }));
        }
        this.setPage(this.currentPage);
    };
    /**
     * @param {?} page
     * @return {?}
     */
    AngularDataTableComponent$$1.prototype.setPage = /**
     * @param {?} page
     * @return {?}
     */
    function (page) {
        var _this = this;
        if (this.color) {
            this.bgColor = this.color;
        }
        this.index = 1;
        this.data.forEach((/**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            element._index = _this.index++;
        }));
        // get pager object from service
        this.pager = this.angularDataTableService.getPager(this.data.length, page, this.itemPerPage);
        // get current page of items
        this.pagedItems = this.data.slice(this.pager.startIndex, this.pager.endIndex + 1);
        // get object property name
        this.propName = Object.getOwnPropertyNames(this.data[0]);
        this.propName.pop();
    };
    /**
     * @return {?}
     */
    AngularDataTableComponent$$1.prototype.nextPage = /**
     * @return {?}
     */
    function () {
        if (this.currentPage < this.pager.pages.length) {
            this.currentPage = this.currentPage + 1;
            this.setPage(this.currentPage);
        }
    };
    /**
     * @return {?}
     */
    AngularDataTableComponent$$1.prototype.previousPage = /**
     * @return {?}
     */
    function () {
        if (this.currentPage > 1) {
            this.currentPage = this.currentPage - 1;
            this.setPage(this.currentPage);
        }
    };
    AngularDataTableComponent$$1.decorators = [
        { type: Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'ang-data-table',
                    template: "<!-- <div class=\"header\">\n  <div class=\"two\" *ngIf=\"pagedItems\">Show\n    <select>\n      <option value=\"10\">10</option>\n      <option value=\"15\">15</option>\n      <option value=\"58\">25</option>\n      <option value=\"100\">100</option>\n    </select> entries\n  </div>\n\n  <div class=\"one\" *ngIf=\"pager.pages && pager.pages.length > 1\">\n    Search: <input type=\"text\">\n  </div>\n</div> -->\n\n<div *ngIf=\"pagedItems\">\n\n<div style=\"overflow-x:auto;\">\n  <table>\n    <thead>\n      <th *ngFor=\"let prop of propName | keyvalue\" [style.background-color]=\"bgColor\">\n        {{ prop.value | titlecase  }} <i class=\"fa fa-sort\" (click)=\"Sorting(prop.value, !sortOrder)\" (click)=\"sortOrder = !sortOrder\">\n        </i></th>\n    </thead>\n    <tbody>\n      <tr *ngFor=\"let item of pagedItems \">\n        <td *ngFor=\"let prop of propName\"> {{ item[prop] }} </td>\n      </tr>\n    </tbody>\n  </table>\n</div>\n\n<br />\n<div class=\"header\" style=\"overflow-x:auto;\">\n  <div class=\"two\" *ngIf=\"pagedItems\">Showing {{pagedItems[0]._index}} to\n    {{pagedItems[pagedItems.length-1]._index}} of\n    {{totalItems}} entries</div>\n\n  <div class=\"one\" *ngIf=\"pager.pages && pager.pages.length > 1\">\n    <button class=\"button button2\" [style.background-color]=\"bgColor\" (click)=\"previousPage()\">Previous</button>\n    <button class=\"button button2\" [style.background-color]=\"bgColor\" (click)=\"nextPage()\">Next</button>\n  </div>\n</div>\n\n<div class=\"center\">\n  Page {{pager.currentPage}}\n</div>\n\n</div>\n\n<!-- CSS -->\n<link href=\"//maxcdn.bootstrapcdn.com/font-awesome/4.1.0/css/font-awesome.min.css\" rel=\"stylesheet\">\n<style>\n  table,\n  td,\n  th {\n    border: 1px solid #ddd;\n    text-align: left;\n  }\n\n  table {\n    border-collapse: collapse;\n    width: 100%;\n  }\n\n  th,\n  td {\n    padding: 15px;\n  }\n\n  th {\n    /* background-color: #24292e; */\n    color: white;\n  }\n\n  tr:hover {\n    background-color: #f5f5f5;\n  }\n\n  .button {\n    /* background-color: #24292e; */\n    border: none;\n    color: white;\n    padding: 10px 24px;\n    text-align: center;\n    text-decoration: none;\n    display: inline-block;\n    font-size: 16px;\n    margin: 4px 2px;\n    cursor: pointer;\n    -webkit-transition-duration: 0.4s;\n    /* Safari */\n    transition-duration: 0.4s;\n  }\n\n  .button2:hover {\n    box-shadow: 0 12px 16px 0 rgba(0, 0, 0, 0.24), 0 17px 50px 0 rgba(0, 0, 0, 0.19);\n  }\n\n  .center {\n    text-align: center;\n  }\n\n\n  .header {\n    display: inline-block;\n    width: 100%;\n  }\n\n  .one {\n    float: right;\n  }\n\n  .two {\n    float: left;\n  }\n</style>\n<!-- CSS --> "
                }] }
    ];
    /** @nocollapse */
    AngularDataTableComponent$$1.ctorParameters = function () { return [
        { type: AngularDataTableService }
    ]; };
    AngularDataTableComponent$$1.propDecorators = {
        data: [{ type: Input }],
        itemPerPage: [{ type: Input }],
        color: [{ type: Input }]
    };
    return AngularDataTableComponent$$1;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularDataTableModule = /** @class */ (function () {
    function AngularDataTableModule() {
    }
    AngularDataTableModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [AngularDataTableComponent$$1],
                    imports: [
                        BrowserModule
                    ],
                    exports: [AngularDataTableComponent$$1]
                },] }
    ];
    return AngularDataTableModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AngularDataTableService, AngularDataTableComponent$$1 as AngularDataTableComponent, AngularDataTableModule };

//# sourceMappingURL=angular-data-table-library.js.map